#ifndef WMBUS_H
#define WMBUS_H

#include <zephyr.h>
#include <logging/log.h>
#include <drivers/uart.h>
#include <zephyr.h>
#include <sys/printk.h>
#include <errno.h>
#include <sys/byteorder.h>
#include <kernel_structs.h>
#include <kernel.h>
#include <stdio.h>

#define WMBUS_THREAD_STACKSIZE 2048
#define WMBUS_THREAD_PRIORITY 7
#define BUF_SIZE 64 // size of the max wmbus frame 
#define METIS_SFD 0xFF

typedef enum {
	CMD_DATA_REQ = 0x00,

	CMD_DATARETRY_REQ = 0x02,
	CMD_DATA_IND,
	CMD_SET_MODE_REQ,
	CMD_RESET_REQ,
	CMD_SET_CHANNEL_REQ,
	CMD_SET_REQ = 0x09,
	CMD_SETUARTSPEED_REQ,
	CMD_GET_REQ,
	CMD_SERIALNO_REQ,
	CMD_FWV_REQ,
	CMD_RSSI_REQ,
	CMD_DATA_PRELOAD_REQ = 0x30,
	CMD_DATA_CLR_PRELOAD_REQ,
	CMD_SET_AES_KEY_REQ = 0x50,
	CMD_CLR_AES_KEY_REQ,
	CMD_GET_AES_DEV_REQ
}wmbus_cmd_t;


struct metis_frame_t{
	uint8_t SFD;
	uint8_t CMD;
	uint8_t len;
	uint8_t *payload;
	uint8_t cs;
};


struct uart_data_t {
	void *fifo_reserved;
	uint8_t  data[BUF_SIZE];
	uint16_t len;
};

void memtis_init(const struct device *uart);
void wmbus_rx_thread(void);
int metis_frame_serialize(const struct device *uart, wmbus_cmd_t cmd, uint8_t * payload, size_t len);
void memtis_enable_deepsleep(const struct device *uart);

void memtis_wakeup(const struct device *uart);

void memtis_get_serial_number(const struct device *uart);
#endif